#include "matrix.h"

Matrix::Matrix() {}

Matrix::~Matrix() {}

double * Matrix::gen(const int M) {
  double * construct = new double[M];
  for (int i = 0 ; i < M ; i++) { 
    construct[i] = 0;
  } 
  return construct;
}

double ** Matrix::gen(const int M, const int N) {
  double ** construct = new double * [M];
  for (int i = 0 ; i < M ; i++) { 
    construct[i] = new double [N];
  }
  for (int i = 0 ; i < M ; i++) {
    for (int j = 0 ; j < N ; j++) { 
      construct[i][j] = 0;
    }
  }
  return construct;
}

double *** Matrix::gen(const int M, const int N, const int Q) {
  double *** construct = new double ** [M];
  for (int i = 0 ; i < M ; i++) { 
    construct[i] = new double * [N];
    for (int j = 0 ; j < N ; j++) { 
      construct[i][j] = new double[Q];
    }
  }
  for (int i = 0 ; i < M ; i++) { 
    for (int j = 0 ; j < N ; j++) { 
      for (int k = 0 ; k < Q ; k++) { 
       construct[i][j][k] = 0;
      }
    }
  }
  return construct;
}

double **** Matrix::gen(const int M, const int N, const int Q, const int S) {
  double **** construct = new double *** [M];
  for (int i = 0 ; i < M ; i++) { 
    construct[i] = new double ** [N];
    for (int j = 0 ; j < N ; j++) { 
      construct[i][j] = new double * [Q];
      for (int k = 0 ; k < Q ; k++) { 
        construct[i][j][k] = new double[S];
      }
    }
  }
  for (int i = 0 ; i < M ; i++) { 
    for (int j = 0 ; j < N ; j++) { 
      for (int k = 0 ; k < Q ; k++) { 
        for (int p = 0 ; p < S ; p++) { 
          construct[i][j][k][p] = 0;
        }
      }
    }
  }
  return construct;
}

double ***** Matrix::gen(const int M, const int N, const int Q, const int S, const int V) { 
  double ***** construct = new double **** [M]; 
  for (int i = 0 ; i < M ; i++) { 
    construct[i] = new double *** [N];
    for (int j = 0 ; j < N ; j++) { 
      construct[i][j] = new double ** [Q];
      for (int k = 0 ; k < Q ; k++) { 
        construct[i][j][k] = new double * [S];
        for (int p = 0 ; p < S ; p++) { 
          construct[i][j][k][p] = new double[V];
        }
      }
    }
  }
  for (int i = 0 ; i < M ; i++) { 
    for (int j = 0 ; j < N ; j++) { 
      for (int k = 0 ; k < Q ; k++) { 
        for (int p = 0 ; p < S ; p++) {
          for (int r = 0 ; r < V ; r++) { 
            construct[i][j][k][p][r] = 0;
          } 
        }
      }
    }
  }
  return construct; 
}

void Matrix::set(double * mat, int mLoc, double val) { 
  mat[mLoc] = val; 
} 

void Matrix::set(double ** mat, int mLoc, int nLoc, double val) { 
  mat[nLoc][mLoc] = val; 
}
void Matrix::set(double *** mat, int mLoc, int nLoc, int qLoc, double val) { 
  mat[mLoc][nLoc][qLoc] = val;
}

void Matrix::set(double **** mat, int mLoc, int nLoc, int qLoc, int sLoc, double val) { 
  mat[mLoc][nLoc][qLoc][sLoc] = val;	
}

void Matrix::set(double ***** mat, int mLoc, int nLoc, int qLoc, int sLoc, int vLoc, double val) {
  mat[mLoc][nLoc][qLoc][sLoc][vLoc] = val; 
}

